//+------------------------------------------------------------------+
//|                   Scooby-doo Multi-Rsi Multi-Lot trading robot.mq4|
//|                                  Copyright  2009, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  up "Up"
#define  down "Down"
#define  none "None"
#define  LongHedgeComment "LongHedge"
#define  ShortHedgeComment "ShortHedge"

/*

----Trading----
void DisplayUserFeedback()
void GetPositionInformation()
void SendSingleTrade(int type, string comment, double lotsize)
bool CloseBasket(int type)
void CheckForPendingTradeDeletion()


----Trade filters----
double ReadRsi(int tf, int period)
void GetSMA()
void GetLinearRegression()


----Hedging----
void DoesBasketNeedHedging(int type)
double GetHedgeLotSize(double LotSize)
void ManageHedgedPosition(int type)

*/

extern string           gen="----General----";
extern double           Lot=0.02;
extern bool             RobotCalculatesLotSize=true;
extern int              LotDivisor=50000;
//extern int              StopLoss=300;
extern int              MagicNumber=833645;
extern string           TradeComment="TCF";
//extern bool             CriminalIsECN=false;
extern bool             AllowClosureInLoss=true;
extern string           trs="----Trading style----";
extern bool             SendImmediateMarketOrder=false;
extern bool             SendPendingOrder=true;
extern int              PendingOrderPips=100;
extern int              PendingOrderDeleteMins=120;
extern int              RsiPeriod=2;
extern string           tls="----Trading levels----";
extern int              Buy1=25;
extern int              Buy2=15;
extern int              Buy3=5;
extern int              BuyClose=75;
extern int              Sell1=75;
extern int              Sell2=85;
extern int              Sell3=95;
extern int              SellClose=25;
extern string           fil="----Filters----";
extern string           hrs="Higher tf Rsi";
extern string           hrd="D1=1440: W1=10080: MN=40320";
extern bool             UseHtf1Rsi=true;
extern int              Htf1RsiMins=240;
extern int              Htf1RsiPeriod=2;
extern bool             UseHtf2Rsi=false;
extern int              Htf2RsiMins=10080;
extern int              Htf2RsiPeriod=2;
extern string           sm="200 SMA";
extern bool             Use200Sma=false;
extern int              SmaPeriod=0;
extern string           lri="Linear Regression";
extern bool             UseLinearRegression=true;       
extern double           MinLrVal=30;
extern int              period=0;
extern int              line.width=2;
extern int              LR.length=34;   // bars back regression begins
extern double           std.channel.1=0.618;        // 1st channel
extern double           std.channel.2=1.618;        // 2nd channel
extern double           std.channel.3=2.618;        // 3nd channel
extern string           hed="----Hedging----";
extern bool             AllowHedging=false;
extern int              HedgePercent=50;
extern double           BreakEvenProfitPercent=0.1;
extern string           bhl="Long trades hdege levels. Select one.";
extern bool             HedgeAtSell1=false;
extern bool             HedgeAtSell2=false;
extern bool             HedgeAtSell3=true;
extern string           shl="Short trades hdege levels. Select one.";
extern bool             HedgeAtBuy1=false;
extern bool             HedgeAtBuy2=false;
extern bool             HedgeAtBuy3=true;
extern string           tt="----Trading hours----";
extern string           Trade_Hours= "Set Morning & Evening Hours 24hr";
extern string           Trade_Hours_M= "Morning Hours 0-12";
extern  int             start_hourm = 0;
extern  int             end_hourm = 12;
extern string           Trade_Hours_E= "Evening Hours 12-24";
extern  int             start_houre = 12;
extern  int             end_houre = 24;

extern string           oae="----Odds and ends----";
extern int              DisplayGapSize=30;
extern bool             ShowAlerts=true;


//Trading
//double                  BasketTakeProfit;
double                  LongBasketUpl;
bool                    LongTrade1Open;
bool                    LongTrade2Open;
bool                    LongTrade3Open;
double                  ShortBasketUpl;
bool                    ShortTrade1Open;
bool                    ShortTrade2Open;
bool                    ShortTrade3Open;
bool                    ForceLongBasketClosure;
bool                    ForceShortBasketClosure;
bool                    LongBasket;
bool                    ShortBasket;
bool                    LongTradeAllowed;
bool                    ShortTradeAllowed;
double                  LongOpenLotSize;
double                  ShortOpenLotSize;
int                     TotalPendingTrades;
int                     TicketNo1;
int                     TicketNo2;
int                     TicketNo3;

//Hedging
bool                    LongHedgeOpen;//Will be a short trade hedging the buys
bool                    ShortHedgeOpen;//Will be a long trade hedging the shorts
int                     LongHedgeTicketNo;
int                     ShortHedgeTicketNo;


//RSI variablew
double                  Rsi;
double                  Htf1Rsi;
double                  Htf2Rsi;

//Linear regression
double                  LinearRegression;
string                  LrDirection;

//Sma
double                  Sma200;
string                  SmaDirection;

//Misc stuff
string                  ScreenMessage, Gap;
bool                    RobotDisabled;
string                  DisabledMessage;

void DisplayUserFeedback()
{

     
   ScreenMessage = "";
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Rsi = ", Rsi, NL);
   if (UseHtf1Rsi) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Htf1Rsi ", "(", Htf1RsiMins, ") = ", Htf1Rsi, NL);
   if (UseHtf2Rsi) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Htf2Rsi ", "(", Htf2RsiMins, ") = ", Htf2Rsi, NL);
   if (Use200Sma)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "200 Sma = ", Sma200, ":  Direction = ", SmaDirection, NL);
   }//if (Use200Sma)
   if (UseLinearRegression)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Linear regression value = ", LinearRegression, ":  Direction = ", LrDirection, NL);
   }//if (UseLinearRegression)
   if (LongTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Long trades are allowed", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Long trades are not allowed", NL);
   if (ShortTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Short trades are allowed", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Short trades are not allowed", NL);
   
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   if (RobotCalculatesLotSize) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Robot is calculating the lot size (LotDivisor = ", LotDivisor, ")", NL);   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot, NL);
   //if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN = true          ", NL);
   //else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN = false          ", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number = ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment = ", TradeComment, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour start = ", start_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour end = ", end_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour start = ", start_houre, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour end = ", end_houre, NL);
   if (SendImmediateMarketOrder) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sending immediate market orders", NL);
   if (SendPendingOrder) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sending pending orders.  PendingOrderPips = ", PendingOrderPips, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading levels", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "        Buy1 = ", Buy1, ": Buy2 = ", Buy2, ": Buy3 = ", Buy3, ": BuyClose = ", BuyClose, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "        Sell1 = ", Sell1, ": Sell2 = ", Sell2, ": Sell3 = ", Sell3, ": SellClose = ", SellClose, NL);
   if (AllowHedging)
   {
      string HedgeMessage;
      double bep = AccountBalance() * (BreakEvenProfitPercent / 100);
      HedgeMessage = StringConcatenate("Hedging is enabled.", NL);
      string LongHedge;
      if (HedgeAtSell1) LongHedge = "Sell1";
      if (HedgeAtSell2) LongHedge = "Sell2";
      if (HedgeAtSell3) LongHedge = "Sell3";
      string ShortHedge;
      if (HedgeAtSell1) ShortHedge = "Buy1";
      if (HedgeAtSell2) ShortHedge = "Buy2";
      if (HedgeAtSell3) ShortHedge = "Buy3";
      
      HedgeMessage = StringConcatenate(HedgeMessage, Gap, "        HedgePercent = ", HedgePercent, "%  : Hedge longs at ", LongHedge,
                     ": Hedge shorts at ", ShortHedge, ":  BreakEvenProfitPercent = ",BreakEvenProfitPercent, " (", DoubleToStr(bep,2), ")");
   }//if (AllowHedging)
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, HedgeMessage, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   if (LongBasket) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Buy basket open. Upl = ", DoubleToStr(LongBasketUpl, 2), ":  Total open lot size = ", LongOpenLotSize, NL);
   if (LongTrade1Open) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "LongTrade1Open", NL);
   if (LongTrade2Open) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "LongTrade2Open", NL);
   if (LongTrade3Open) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "LongTrade3Open", NL);
   if (LongHedgeOpen) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Long hedge trade", NL);
   if (ShortBasket) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sell basket open. Upl = ", DoubleToStr(ShortBasketUpl, 2), ":  Total open lot size = ", ShortOpenLotSize, NL);
   if (ShortTrade1Open) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "ShortTrade1Open", NL);
   if (ShortTrade2Open) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "ShortTrade2Open", NL);
   if (ShortTrade3Open) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "ShortTrade3Open", NL);
   if (ShortHedgeOpen) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Short hedge trade", NL);
   
   
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "--", NL);
   Comment(ScreenMessage);

}//void DisplayUserFeedback()

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
   
  
   //Check magic number.
   if (!IsDemo() )
   {
      if (MagicNumber == 833645)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 833645." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 12345)
   }//if (!IsDemo)
      
   //Insufficient length
   string mn = DoubleToStr(MagicNumber,0);
   if (StringLen(mn) < 5)
   {
      MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                 + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
      Comment("                This robot can do nothing. Please reload it");
      DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
      RobotDisabled = true;
      return;
   }//if (StringLen(mn) < 5)



   //Adjust settings for 4 digit crim
   if (Digits == 2 || Digits == 4)
   {
      //StopLoss/= 10;
      PendingOrderPips/= 10;
   }//if (Digits == 2 || Digits == 4)

   
   
   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }

   if (Sma200 == 0) SmaPeriod = Period();

   //start();
   //return;
   
   
   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   
//----
   return(0);
}

void GetPositionInformation()
{
   LongBasketUpl = 0;
   ShortBasketUpl = 0;
   ForceLongBasketClosure = false;
   ForceShortBasketClosure = false;
   LongTrade1Open = false;
   LongTrade2Open = false;
   LongTrade3Open = false;
   ShortTrade1Open = false;
   ShortTrade2Open = false;
   ShortTrade3Open = false;
   LongBasket = false;
   ShortBasket = false;
   LongHedgeOpen = false;//Will be a short trade hedging the buys
   ShortHedgeOpen = false;//Will be a long trade hedging the shorts
   LongHedgeTicketNo = false;
   ShortHedgeTicketNo = false;
   LongOpenLotSize = 0;
   ShortOpenLotSize = 0;
   TotalPendingTrades = 0;
   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal(); cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         if (OrderComment() == TradeComment + "1")
         {
            TicketNo1 = OrderTicket();
            if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
            {
               LongBasket = true;
               LongTrade1Open = true;
               LongBasketUpl+= OrderProfit();
               LongOpenLotSize+= OrderLots();               
            }//if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
            
            if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) 
            {
               ShortBasket = true;
               ShortTrade1Open = true;
               ShortBasketUpl+= OrderProfit();
               ShortOpenLotSize+= OrderLots();
            }//if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) 
            if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) TotalPendingTrades++;
         }//if (OrderComment() = TradeComment;
         
         if (OrderComment() == TradeComment + "2")
         {
            TicketNo2 = OrderTicket();
            if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
            {
               LongBasket = true;
               LongTrade2Open = true;
               LongBasketUpl+= OrderProfit();
               LongOpenLotSize+= OrderLots();               
            }//if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
            
            if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) 
            {
               ShortBasket = true;
               ShortTrade2Open = true;
               ShortBasketUpl+= OrderProfit();
               ShortOpenLotSize+= OrderLots();
            }//if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) 
            if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) TotalPendingTrades++;
         }//if (OrderComment() = TradeComment;
         
         if (OrderComment() == TradeComment + "3")
         {
            TicketNo3 = OrderTicket();
            if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
            {
               LongBasket = true;
               LongTrade3Open = true;
               LongBasketUpl+= OrderProfit();
               LongOpenLotSize+= OrderLots();
            }//if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
            
            if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) 
            {
               ShortBasket = true;
               ShortTrade3Open = true;
               ShortBasketUpl+= OrderProfit();
               ShortOpenLotSize+= OrderLots();
            }//if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) 
            if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) TotalPendingTrades++;
         }//if (OrderComment() = TradeComment;
         
         //Hedges
         if (OrderComment() == LongHedgeComment)
         {
            LongHedgeOpen = true;
            LongHedgeTicketNo = OrderTicket();
            LongBasketUpl+= OrderProfit();
         }//if (OrderComment() == LongHedgeComment)
         
         if (OrderComment() == ShortHedgeComment)
         {
            ShortHedgeOpen = true;
            ShortHedgeTicketNo = OrderTicket();
            ShortBasketUpl+= OrderProfit();
         }//if (OrderComment() == LongHedgeComment)
         
            
      }//if (OrderMagicNumber()==MagicNumber)
   }//for (int cc=0; cc<OrdersTotal(); cc++)


}//void GetPositionInformation()


void SendSingleTrade(int type, string comment, double lotsize)
{
   // Attempts to place a trade according to type, i.e.
   // 0 = OP_BUY
   // 1 = OP_SELL
   
   // Check spread
   //if (MarketInfo(Symbol(), MODE_SPREAD) > MaxSpreadAllowed)
   //{
      //return(false);// Spread too large, so abort send
   //}//if (MarketInfo(NULL, MODE_SPREAD) > MaxSpreadAllowed)
   
   RefreshRates();
   
   // Buy trade
   if (type == 0)
   {
      double TradePrice=Ask;
      int colour = 32768;//green
      datetime expiry = 0;
      //double SL = NormalizeDouble(TradePrice - (StopLoss * Point), Digits);      
   }//if (type == 0)   
   
   //Buy stop trade
   if (type == OP_BUYSTOP)
   {
      TradePrice = NormalizeDouble(Ask + (PendingOrderPips * Point), Digits);
      colour = 32768;//green
      //expiry = TimeCurrent()+(PendingOrderDeleteMins*60);
   }//if (type == 4)
   
   
   // Sell trade
   if (type == 1)
   {
      TradePrice=Bid;      
      colour = 255;//red
      //expiry = 0;
      //SL = NormalizeDouble(TradePrice + (StopLoss * Point), Digits);      
   }//if (type == 1)
   
   //Sell stop trade
   if (type == OP_SELLSTOP)
   {
      TradePrice = NormalizeDouble(Bid - (PendingOrderPips * Point), Digits);
      colour = 255;//red
      //expiry = TimeCurrent()+(PendingOrderDeleteMins*60);
   }//if (type == 4)
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   
   int ticket = OrderSend(Symbol(),type, lotsize, TradePrice, slippage, 0, 0, comment, MagicNumber, expiry, colour);
   
/*
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   The ECN stuff is not needed by this robot. Leave it in place, just in case we change our minds
   //Non ECN crook
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, TradePrice, slippage, 0, 0, comment, MagicNumber,0, colour);
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, TradePrice, slippage, 0, 0, comment, MagicNumber,0, colour);
	   if (SL != 0)
	   {
		   if (ticket > 0)
		   bool result = OrderModify(ticket, OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
		   if (!result)
		   {
		       int err=GetLastError();
             Alert(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
		   }//if (!result)			  
	   }//if (Sl != 0)
      
      
   }//if (CriminalIsECN)
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
*/
   
   //Error trapping for both
   if (ticket < 0)
   {
      int err=GetLastError();
      if (ShowAlerts) Alert(Symbol(), " ", type," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)
   
   if (ticket > 0 && comment == LongHedgeComment && ShowAlerts) Alert("Long hedge ", ticket);
   if (ticket > 0 && comment == ShortHedgeComment && ShowAlerts) Alert("Short hedge ", ticket);


}//End void SendSingleTrade(type, string comment, double lotsize)

double ReadRsi(int tf, int period)
{

   return(iRSI(Symbol(), tf, period, PRICE_CLOSE, 0) );

}//double ReadRsi(int tf, int period)

bool CloseBasket(int type)
{
   //Called whenever an entire trading basket needs closing.
   //Returns true if all trades close successfully, else false
   
   bool success=true;// Set to false if a closure fails
   
   
   for (int cc = OrdersTotal(); cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() && OrderType() == type
      && OrderComment() != LongHedgeComment && OrderComment() != ShortHedgeComment)         
      {
         bool result = OrderClose(OrderTicket(),OrderLots(), OrderClosePrice(),100,CLR_NONE);            
         if (!result) success = false;
         else cc++;
         Sleep(100);
      }//if (OrderMagicNumber()==MagicNumber)
   }//for (int cc=0; cc<OrdersTotal(); cc++)

   //Hedge trades
   if (type == 0 && LongHedgeTicketNo > 0)
   {
      if (!OrderSelect(LongHedgeTicketNo, SELECT_BY_TICKET) ) return;
      if (OrderCloseTime() == 0)
      {
         result = OrderClose(OrderTicket(),OrderLots(), OrderClosePrice(),100,CLR_NONE);            
         if (!result) success = false;
      }//if (OrderCloseTime() == 0)
   }//if (type == 0 && LongHedgeTicketNo > 0)
   
   if (type == 1 && ShortHedgeTicketNo > 0)
   {
      if (!OrderSelect(ShortHedgeTicketNo, SELECT_BY_TICKET) ) return;
      if (OrderCloseTime() == 0)
      {
         result = OrderClose(OrderTicket(),OrderLots(), OrderClosePrice(),100,CLR_NONE);            
         if (!result) success = false;
      }//if (OrderCloseTime() == 0)   
   }//if (type == 0 && LongHedgeTicketNo > 0)
   
   
   return(result);
   

}//End bool CloseBasket(int type)

void GetSMA()
{
   Sma200 = iMA(Symbol(), SmaPeriod, 200, 0, MODE_SMA, PRICE_CLOSE, 0);
   SmaDirection = none;
   if (Bid > Sma200) SmaDirection = up;
   if (Bid < Sma200) SmaDirection = down;
   
   
}//End void GetSMA()

void GetLinearRegression()
{
   //linear regression calculation
   int start.bar=LR.length, end.bar=0;
      int n=start.bar-end.bar+1;
   //---- calculate price values
      double value=iClose(Symbol(),period,end.bar);
      double a,b,c;
      double sumy=value;
      double sumx=0.0;
      double sumxy=0.0;
      double sumx2=0.0;
      for(int i=1; i<n; i++)
        {
         value=iClose(Symbol(),period,end.bar+i);
         sumy+=value;
         sumxy+=value*i;
         sumx+=i;
         sumx2+=i*i;
        }
      c=sumx2*n-sumx*sumx;
      if(c==0.0) return;
      b=(sumxy*n-sumx*sumy)/c;
      a=(sumy-sumx*b)/n;
      double LR.price.2=a;
      double LR.price.1=a+b*n;

      double upperBound = High[iHighest(Symbol(),0,MODE_HIGH,n,0)];
      double lowerBound = Low[iLowest(Symbol(),0,MODE_LOW,n,0)];
      double theSlopeFactor = MathAbs(upperBound-lowerBound);
   
      double onePrcOfSlope = theSlopeFactor/100;
      double theRegressionFactor = LR.price.2 - LR.price.1;
   
      LinearRegression = theRegressionFactor/onePrcOfSlope;
      //Comment(theRegressionFactor/onePrcOfSlope);
      //Comment(result);
   
   
   //---- maximal deviation calculation (not used)
      double max.dev=0;
      double deviation=0;
      double dvalue=a;
      for(i=0; i<n; i++)
        {
         value=iClose(Symbol(),period,end.bar+i);
         dvalue+=b;
         deviation=MathAbs(value-dvalue);
         if(max.dev<=deviation) max.dev=deviation;
        }
   //Linear regression trendline
     
   //...standard deviation...
      double x=0,x.sum=0,x.avg=0,x.sum.squared=0,std.dev=0;
      for(i=0; i<start.bar; i++)    {
         x=MathAbs(iClose(Symbol(),period,i)-ObjectGetValueByShift(period+"m "+LR.length+" TL",i));
         x.sum+=x;
         if(i>0)  {
            x.avg=(x.avg+x)/i;
            x.sum.squared+=(x-x.avg)*(x-x.avg);
            std.dev=MathSqrt(x.sum.squared/(start.bar-1));  }  }
      //Print("LR.price.1 ",LR.price.1,"  LR.Price.2 ",LR.price.2," std.dev ",std.dev);


}//void GetLinearRegression()

double GetHedgeLotSize(double LotSize)
{
   //Returns as near as possible 50% of total basket trades' lot sizes
   
   double MinLot = MarketInfo(Symbol(), MODE_MINLOT);   
   //Make sure that there are not too many decimal places in the result of the calculation
   int decimals;
   if (MinLot >0 && MinLot < 0.1) decimals = 2;//0.01
   if (MinLot >0.09 && MinLot < 1) decimals = 1;//0.1
   if (MinLot >0.9) decimals = 0;//1   
   double RetLot = NormalizeDouble(LotSize / 2, decimals);
   if (RetLot < MinLot) RetLot = MinLot;

   return(RetLot);
}//End double GetHedgeLotSize(double LotSize)



void DoesBasketNeedHedging(int type)
{
   //Tests for the need to hedge and sends the trade if so.
   //Only called if user has chosen hedging, basket upl is < 0 and there is no hedge already in place

   //Long basket
   if (type == 0)
   {
      double HedgePoint;
      if (HedgeAtSell1) HedgePoint = Sell1;
      if (HedgeAtSell2) HedgePoint = Sell2;
      if (HedgeAtSell3) HedgePoint = Sell3;
      
      if (Rsi > HedgePoint)
      {
         double HedgeLotSize = GetHedgeLotSize(LongOpenLotSize);
         SendSingleTrade(1, LongHedgeComment, HedgeLotSize);
      }//if (Rsi > HedgePoint)
   }//if (type == 1)
   
   //Short basket
   if (type == 1)
   {
      if (HedgeAtBuy1) HedgePoint = Buy1;
      if (HedgeAtBuy2) HedgePoint = Buy2;
      if (HedgeAtBuy3) HedgePoint = Buy3;
      
      if (Rsi < HedgePoint)
      {
         HedgeLotSize = GetHedgeLotSize(ShortOpenLotSize);
         SendSingleTrade(0, ShortHedgeComment, HedgeLotSize);
      }//if (Rsi < HedgePoint)
   }//if (type == 1)
   

}//End void DoesBasketNeedHedging(0)

void ManageHedgedPosition(int type)
{
   //Monitors hedged position for closure opportunity. Only called if a position is hedged
   
   double BreakEvenTarget = NormalizeDouble(AccountBalance() * BreakEvenProfitPercent / 100, 2);

   //Long basket
   if (type == 0)
   {
      if (LongBasketUpl >= BreakEvenTarget)
      {
         bool success = CloseBasket(0);
         if (!success) ForceLongBasketClosure = true;
      }//if (LongBasketUpl >= BreakEvenTarget)
   }//if (type == 0)
   
   //Short basket
   if (type == 1)
   {
      if (ShortBasketUpl >= BreakEvenTarget)
      {
         success = CloseBasket(0);
         if (!success) ForceShortBasketClosure = true;
      }//if (ShortBasketUpl >= BreakEvenTarget)
   }//if (type == 0)
   

}//End void ManageHedgedPosition(0)

void CheckForPendingTradeDeletion()
{

   OrderSelect(TicketNo3, SELECT_BY_TICKET);
   if (OrderCloseTime() == 0)
   {
      double DeleteSecs = (PendingOrderDeleteMins * 60);
      if (TimeCurrent() - OrderOpenTime() >= DeleteSecs)
      {
         while (!IsTradeAllowed() )
         {
            Sleep(100);
         }//while (!IsTradeAllowed)
         
         bool done = false;
         while (!done)
         {
            Sleep(10);
            done = !OrderDelete(TicketNo3);
         }//while (!done)
         
         done = false;
         while (!done)
         {
            Sleep(10);
            done = true;
            done = !OrderDelete(TicketNo2);
         }//while (!done)
         
         done = false;
         while (!done)
         {
            Sleep(10);
            done = true;
            done = !OrderDelete(TicketNo1);
         }//while (!done)
         
      }//if (TimeCurrent() - OrderCloseTime() >= DeleteSecs)         
   }//if (OrderCloseTime() == 0)
   
   
}//End void CheckForPendingTradeDeletion()


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   
   
   //In case a previous basket close attempt failed
   if (ForceLongBasketClosure)
   {
      bool AllClosed = CloseBasket(0);
      if (AllClosed) ForceLongBasketClosure = false;
      if (!AllClosed) return;
   }//if (ForceLongBasketClosure)

   if (ForceShortBasketClosure)
   {
      AllClosed = CloseBasket(1);
      if (AllClosed) ForceLongBasketClosure = false;
      if (!AllClosed) return;
   }//if (ForceLongBasketClosure)

   
   if (!IsDemo())
   {
      if (RobotDisabled)
      {
         Comment("The robot has been suspended. Reason: ", DisabledMessage);
         return;
      }//if (RobotDisabled )

      if (IsTradeContextBusy() )
      {
         Comment("Trade context is busy because the criminal is too lazy, dim or both to provide a decent server. Please wait for the cretin to stop pissing around.");
         return;
      }//if (IsTradeContextBusy)
   }//if (!IsDemo)

            
   //Check whether pending trade time limit has passed
   if (TotalPendingTrades == 3) CheckForPendingTradeDeletion();
         
   
   //Auto lot calc
   if (RobotCalculatesLotSize)
   {
      double MinLot = MarketInfo(Symbol(), MODE_MINLOT);   
      //Make sure that there are not too many decimal places in the result of the calculation
      int decimals;
      if (MinLot >0 && MinLot < 0.1) decimals = 2;//0.01
      if (MinLot >0.09 && MinLot < 1) decimals = 1;//0.1
      if (MinLot >0.9) decimals = 0;//1   
      Lot = NormalizeDouble(AccountEquity() / LotDivisor, decimals);
      if (Lot < MinLot) Lot = MinLot;
   }//if (RobotCalculatesLotSize)
   
   
   
   //Trading hours
   bool TradeHour = false;
   if ((Hour()>=start_hourm && Hour()<end_hourm) || (Hour()>=start_houre && Hour()<end_houre)) TradeHour = true;
   if (!TradeHour)
   {
      Comment(Gap, "Trading suspended - outside trade hours");
      return;
   }//if (!TradeHour)
   
   
   //Essential rsi reading
   Rsi = ReadRsi(Period(), RsiPeriod);
   
   
   LongTradeAllowed = true;
   ShortTradeAllowed = true;
   
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Trade filters. Work throught them, cancelling Long\ShortTradeAllowed as appropriate

   //Rsi higher tf
   if (UseHtf1Rsi)
   {
      Htf1Rsi = ReadRsi(Htf1RsiMins, Htf1RsiPeriod);
      if (Htf1Rsi > Buy1) LongTradeAllowed = false;
      if (Htf1Rsi < Sell1) ShortTradeAllowed = false;      
   }//if (UseHtf1Rsi)
   
   if (UseHtf2Rsi)
   {
      Htf2Rsi = ReadRsi(Htf2RsiMins, Htf2RsiPeriod);
      if (Htf2Rsi > Buy1) LongTradeAllowed = false;
      if (Htf2Rsi < Sell1) ShortTradeAllowed = false;      
   }//if (UseHtf2Rsi)
   
   
   
   //200 sma
   if (Use200Sma)
   {
      GetSMA();
      if (!SmaDirection == up) LongTradeAllowed = false;
      if (!SmaDirection == down) ShortTradeAllowed = false;
   }//if (Use200Sma)
   
   //LR
   if (UseLinearRegression)
   {
      GetLinearRegression();
      LrDirection = none;
      if (LinearRegression > MinLrVal) LrDirection = up;
      if (LinearRegression < -MinLrVal) LrDirection = down;
      if (LrDirection == up) ShortTradeAllowed = false;
      if (LrDirection == down) LongTradeAllowed = false;
      if (LrDirection == none)
      {
         ShortTradeAllowed = false;
         LongTradeAllowed = false;
      }//if (LrDirection = none)
      
      
   }//if (UseLinearRegression)
   
   
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   


   //Is there a trade\trades already open?
   GetPositionInformation();
   
   //Manage hedged positions
   if (LongHedgeOpen)
   {
      ManageHedgedPosition(0);
      if (ForceLongBasketClosure) return;
   }//if (LongHedgeOpen)
   
   if (ShortHedgeOpen)
   {
      ManageHedgedPosition(1);
      if (ForceShortBasketClosure) return;
   }//if (LongHedgeOpen)
   
   
   //If so, do they need hedging
   if (LongBasket && LongBasketUpl < 0 && AllowHedging && !LongHedgeOpen)
   {
      DoesBasketNeedHedging(0);
   }//if (LongBasket)
   
   if (ShortBasket && ShortBasketUpl < 0 && AllowHedging && !ShortHedgeOpen)
   {
      DoesBasketNeedHedging(1);
   }//if (ShortBasket)
   
   
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////   
   //Trading decisions
   if (ShortTradeAllowed)
   {
      if (Rsi >= Sell1 && !ShortTrade1Open)
      {
         if (SendImmediateMarketOrder) SendSingleTrade(1, TradeComment + "1", Lot);
         if (SendPendingOrder) SendSingleTrade(OP_SELLSTOP, TradeComment + "1", Lot);
         return;
      }//if (Rsi >= 70 && Rsi < 80 && !LongTrade1Open)
   
      if (Rsi >= Sell2 && !ShortTrade2Open)
      {
         if (SendImmediateMarketOrder) SendSingleTrade(1, TradeComment + "2", Lot * 2);
         if (SendPendingOrder) SendSingleTrade(OP_SELLSTOP, TradeComment + "2", Lot * 2);
         return;
      }//if (Rsi >= 70 && Rsi < 80 && !LongTrade1Open)
   
      if (Rsi >= Sell3 && !ShortTrade3Open)
      {
         if (SendImmediateMarketOrder) SendSingleTrade(1, TradeComment + "3", Lot * 3);
         if (SendPendingOrder) SendSingleTrade(OP_SELLSTOP, TradeComment + "3", Lot * 3);
         return;
      }//if (Rsi >= 70 && Rsi < 80 && !LongTrade1Open)
   }//if (ShortTradeAllowed)
   
   
   if (LongTradeAllowed)
   {
   
      if (Rsi <= Buy1 && !LongTrade1Open)
      {
         if (SendImmediateMarketOrder) SendSingleTrade(0, TradeComment + "1", Lot);
         if (SendPendingOrder) SendSingleTrade(OP_BUYSTOP, TradeComment + "1", Lot);
         return;
      }//if (Rsi <= 30 && Rsi > 20 && !LongTrade1Open)
   
      if (Rsi <= Buy2 && !LongTrade2Open)
      {
         if (SendImmediateMarketOrder) SendSingleTrade(0, TradeComment + "2", Lot * 2);
         if (SendPendingOrder) SendSingleTrade(OP_BUYSTOP, TradeComment + "2", Lot * 2);
         return;
      }//if (Rsi <= 20 && Rsi > 10 && !LongTrade2Open)
   
      if (Rsi <= Buy3 && !LongTrade3Open)
      {
         if (SendImmediateMarketOrder) SendSingleTrade(0, TradeComment + "3", Lot * 3);
         if (SendPendingOrder) SendSingleTrade(OP_BUYSTOP, TradeComment + "3", Lot * 3);
         return;
      }//if (Rsi <= 10 && !LongTrade3Open)
   }//if (LongTradeAllowed)
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
   
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Basket closing decisions
   int CloseTarget;
   if (!AllowClosureInLoss) CloseTarget = 0;
   else CloseTarget = -99999;

   if (LongBasket && Rsi >= BuyClose && LongBasketUpl >= CloseTarget && !LongHedgeOpen)
   {
      CloseBasket(0);
   }//if (LongBasket && Rsi >= BuyClose)
   
   if (ShortBasket && Rsi <= SellClose && ShortBasketUpl >= CloseTarget && !ShortHedgeOpen)
   {
      CloseBasket(1);
   }//if (ShortBasket && Rsi <= BuyClose)
   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
   
   DisplayUserFeedback();
   
   
//----
   return(0);
}
//+------------------------------------------------------------------+