//+------------------------------------------------------------------+
//|              Scooby-doo Trend Retracement auto trading robot.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define up "Up"
#define down "Down"
#define flat "Flat"

/*

void DisplayUserFeedback()
int start()
void GetPosition()
void Get_Trend(string symbol)
bool NewsExist()
void SendOrder(string symbol, int dir, double lots)
bool DoesTradeExist(string symbol)
void ManageTrades()

----ATR----
double Get_ATR(string symbol, int tf, int multiplier)


----Pairs traded----
void CleanUpInputString()
void CalculatePairsPassed()

*/


extern string  PairsToTrade = "AUDJPY,AUDUSD,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURUSD,GBPJPY,GBPUSD,USDCAD,USDCHF,USDJPY";
extern double  Lots = 0.02;
extern int     MagicNumber = 563656;
extern string  TradeComment="ScRT";
extern bool    CriminalIsECN=false;
extern int     MaxTradesAllowed=6;
extern int     PendingTradesPipsDistance=150;
extern int     PendingTradesExpireMinutes=60;
extern int     AtrPeriod=14;
extern string  atrs="----ATR Retrace settings. Select one----";
extern bool    UseM15ATRrt=true;
extern bool    UseH1ATRrt=false;
extern bool    UseH4ATRrt=false;
extern bool    UseD1ATRrt=false;
extern double  RetraceAtrMultiplier=1;
extern string  tps="----Take profit settings. Select one----";
extern bool    UseM15ATRtp=false;
extern bool    UseH1ATRtp=false;
extern bool    UseH4ATRtp=false;
extern bool    UseD1ATRtp=true;
extern double  TpAtrMultiplier=1;
extern string  sls="----Stop loss settings. Select one----";
extern bool    UseM15ATRsl=false;
extern bool    UseH1ATRsl=false;
extern bool    UseH4ATRsl=false;
extern bool    UseD1ATRsl=true;
extern double  SlAtrMultiplier=1;
extern string  wei="----Week ending inputs----";
extern bool    FridayClose=true;
extern bool    SaturdayClose=false;
extern int     CloseHour = 12;
extern string  oae="----Odds and ends----";
extern int     DisplayGapSize=30;
extern bool    ShowPairsInformation=true;
extern bool    ShowAlerts=true;



//MA timeframes
int   M05 = PERIOD_M5;
int   M15 = PERIOD_M15;
int   M30 = PERIOD_M30;
int   H01 = PERIOD_H1;
int   H04 = PERIOD_H4;
int   D01 = PERIOD_D1;

//Trading
int   TicketNo;
int   NoOfTrades;

//Trading hours
bool  ClosedForFriday;
bool  ClosedForSaturday;

//Stop and tp ATR periods
int   RetraceAtrTf;
int   TpAtrTf;
int   SlAtrTf;
double EMA_020_M15;

//Pair extraction
string    InputString;//Holds the contents PairsToTrade for tidying yp etc
int       NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string    TradePair[]; //Array to hold the pairs traded by the user

//Misc stuff
int Decimals;
string Trend, ScreenMessage, Gap;
bool   RobotDisabled;
string DisabledMessage;


void DisplayUserFeedback()
{

   ScreenMessage = "";
   int cc;
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading ", PairsToTrade, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lots, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment: ", TradeComment, NL);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is true ", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is false ", NL);
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TradeHourStart = ", TradeHourStart, NL);
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TradeHourStop = ", TradeHourStop, NL);
   if (FridayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(CloseHour, 2), NL);
   if (SaturdayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(CloseHour, 2), NL);
   if (ClosedForSaturday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Saturday close. Continuing to monitor open trades.", NL);
   if (ClosedForFriday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Friday close. Continuing to monitor open trades.", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Retrace ATR period = ", RetraceAtrTf, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Take profit ATR period = ", TpAtrTf, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop loss ATR period = ", SlAtrTf, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pending pips distance = ", PendingTradesPipsDistance, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pending trades expiry = ", PendingTradesExpireMinutes, " minutes", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
      
   
   //Display pairs information
   if (ShowPairsInformation)
   {
      for (cc = 0; cc < NoOfPairs; cc++)
      {
         Get_Trend(TradePair[cc] );
         //double TpAtr = Get_ATR(TradePair[cc], TpAtrTf, TpAtrMultiplier);
         //double SlAtr = Get_ATR(TradePair[cc], SlAtrTf, SlAtrMultiplier);
         int digits = MarketInfo(TradePair[cc], MODE_DIGITS);
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, TradePair[cc], " trend direction: ", Trend);
                         //": TP ATR = ", TpAtr, ": SL ATR = ", SlAtr, NL);
         if (Trend == up)
         {
            double AtrVal = Get_ATR(TradePair[cc], RetraceAtrTf, RetraceAtrMultiplier);
            double price = NormalizeDouble(EMA_020_M15 - AtrVal, digits);
            double ask = MarketInfo(TradePair[cc], MODE_ASK);
            ScreenMessage = StringConcatenate(ScreenMessage, " ( Ask = ", DoubleToStr(ask, digits), ": Will go long at ", DoubleToStr(price, digits), ")");
         }//if (Trend == up)
         
         if (Trend == down)
         {
            AtrVal = Get_ATR(TradePair[cc], RetraceAtrTf, RetraceAtrMultiplier);
            price = NormalizeDouble(EMA_020_M15 + AtrVal, digits);
            double bid = MarketInfo(TradePair[cc], MODE_BID);
            ScreenMessage = StringConcatenate(ScreenMessage, " ( Bid = ", DoubleToStr(bid, digits), ": Will go short at ", DoubleToStr(price, digits), ")");
         }//if (Trend == down)
         
         ScreenMessage = StringConcatenate(ScreenMessage, NL);                
      }//for (cc = 0; cc < NoOfCurrencies; cc==)
   }//if (ShowPairsInformation)
   
   Comment(ScreenMessage);
   
}//End void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 563656)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 563656." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)
      
      //Default trade comment needs changing
      if (TradeComment == "ScRT")
      {
         MessageBox("You cannot run this robot until changed the TradeComment input from the default of ScRT." + NL 
                    + "Please reload the robot with a new TradeComment input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the TradeComment input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 876987)            
   }//if (!IsDemo)
   
   
   //Amend inputs to cater for different broker digits
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   if (dig == 2 || dig == 4)
   {   
      PendingTradesPipsDistance/= 10;
      
   }//if (dig = 3)
   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the array appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         LastIndex = Index+1;         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    Comment("\nWaiting for tick update...");
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }

   //Set up ATR call variables
   //Retrace
   if (UseM15ATRrt) RetraceAtrTf = PERIOD_M15;
   if (UseH1ATRrt) RetraceAtrTf = PERIOD_H1;
   if (UseH4ATRrt) RetraceAtrTf = PERIOD_H4;
   if (UseD1ATRrt) RetraceAtrTf = PERIOD_D1;
   
   //TP
   if (UseM15ATRtp) TpAtrTf = PERIOD_M15;
   if (UseH1ATRtp) TpAtrTf = PERIOD_H1;
   if (UseH4ATRtp) TpAtrTf = PERIOD_H4;
   if (UseD1ATRtp) TpAtrTf = PERIOD_D1;
   //SL
   if (UseM15ATRsl) SlAtrTf = PERIOD_M15;
   if (UseH1ATRsl) SlAtrTf = PERIOD_H1;
   if (UseH4ATRsl) SlAtrTf = PERIOD_H4;
   if (UseD1ATRsl) SlAtrTf = PERIOD_D1;
   
   DisplayUserFeedback();
   start();
   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {

    Comment("");
    
    return(0);

  }
  
//+------------------------------------------------------------------+
//| expert GetPosition function                                      |
//+------------------------------------------------------------------+

void GetPosition()
{

   NoOfTrades = 0;
   if (OrdersTotal() == 0 ) return;
   
   for(int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
       if(!OrderSelect(cc, SELECT_BY_POS, MODE_TRADES) ) continue;
         
       if(OrderMagicNumber() == MagicNumber)
       {
           NoOfTrades++;
       }//if(OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         
   }//for(int cc = 0; cc <= OrdersTotal(); cc++)
 
 
}//void GetPosition(string symbol)


//+------------------------------------------------------------------+
//| expert SendOrder function                                        |
//+------------------------------------------------------------------+  

  void SendOrder(string symbol, int dir, double lots) 
  {
    
    double price;
    double point;
    double sl;
    double tp;

    int ticket = -1;
    int spread = 10;
    int digit  = 0;
        
    if(MarketInfo(symbol,MODE_DIGITS) == 3 || MarketInfo(symbol,MODE_DIGITS) == 5)
      {
        spread *= 10;
      }
    
   //Trade expiry time
   datetime OrderExpiryTime = TimeCurrent();
   OrderExpiryTime += PendingTradesExpireMinutes * 60;
   
    if(dir == OP_BUY && MarketInfo(symbol,MODE_SPREAD) <= spread)
      {
        while(ticket < 0)
          {
            RefreshRates();
            price  = MarketInfo(symbol,MODE_ASK);
            point  = MarketInfo(symbol,MODE_POINT);
            digit  = MarketInfo(symbol,MODE_DIGITS);
            double AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
            sl     = NormalizeDouble(price-AtrVal,digit);
            AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
            tp     = NormalizeDouble(price+AtrVal,digit);
            //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (!CriminalIsECN) ticket = OrderSend(symbol,OP_BUY,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (CriminalIsECN) ticket = OrderSend(symbol,OP_BUY,lots,price,3,0,0,TradeComment,MagicNumber,0,CLR_NONE);
            
            Sleep(1000);
          }
          if (CriminalIsECN)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               bool result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          int err=GetLastError();
                   if (ShowAlerts) Alert(Symbol(), " Buy TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }
      }//if(dir == OP_BUY && MarketInfo(symbol,MODE_SPREAD) <= spread)
      
   if(dir == OP_BUYSTOP)
      {
        
         RefreshRates();
         point  = MarketInfo(symbol,MODE_POINT);
         digit  = MarketInfo(symbol,MODE_DIGITS);
         price  = NormalizeDouble(MarketInfo(symbol,MODE_ASK) + (PendingTradesPipsDistance * point), digit);
         AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
         sl     = NormalizeDouble(price-AtrVal,digit);
         AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
         tp     = NormalizeDouble(price+AtrVal,digit);
         //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
         if (!CriminalIsECN) ticket = OrderSend(symbol,OP_BUYSTOP,lots,price,3,sl,tp,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);
         if (CriminalIsECN) ticket = OrderSend(symbol,OP_BUYSTOP,lots,price,3,0,0,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);
         
         Sleep(1000);
          
          if (CriminalIsECN && ticket > -1)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          err=GetLastError();
                   if (ShowAlerts) Alert(Symbol(), " Buy TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }
      }//f(dir == OP_BUYSTOP)
      
    if(dir == OP_SELL && MarketInfo(symbol,MODE_SPREAD) <= spread)
      {
        while(ticket < 0)
          {
            RefreshRates();
            price  = MarketInfo(symbol,MODE_BID);
            point  = MarketInfo(symbol,MODE_POINT);
            digit  = MarketInfo(symbol,MODE_DIGITS);
            AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
            sl     = NormalizeDouble(price+AtrVal,digit);
            AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
            tp     = NormalizeDouble(price-AtrVal,digit);
            //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (!CriminalIsECN) ticket = OrderSend(symbol,OP_SELL,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (CriminalIsECN) ticket = OrderSend(symbol,OP_SELL,lots,price,3,0,0,TradeComment,MagicNumber,0,CLR_NONE);            
            Sleep(1000);
          }
          if (CriminalIsECN)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          err=GetLastError();
                   if (ShowAlerts) Alert(Symbol(), " Sell TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }//if (CriminalIsECN)
      
      if (ticket > -1) NoOfTrades++;//Ensure trades are sent only up to MaxTradesAllowed
  }//if(dir == OP_SELL && MarketInfo(symbol,MODE_SPREAD) <= spread)

    if(dir == OP_SELLSTOP)
      {
        
         RefreshRates();
         point  = MarketInfo(symbol,MODE_POINT);
         digit  = MarketInfo(symbol,MODE_DIGITS);
         price  = NormalizeDouble(MarketInfo(symbol,MODE_BID) - (PendingTradesPipsDistance * point), digit);
         AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
         sl     = NormalizeDouble(price+AtrVal,digit);
         AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
         tp     = NormalizeDouble(price-AtrVal,digit);
         //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
         if (!CriminalIsECN) ticket = OrderSend(symbol,OP_SELLSTOP,lots,price,3,sl,tp,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);
         if (CriminalIsECN) ticket = OrderSend(symbol,OP_SELLSTOP,lots,price,3,0,0,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);            
         Sleep(1000);
          
          if (CriminalIsECN && ticket > -1)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          err=GetLastError();
                   if (ShowAlerts) Alert(Symbol(), " Sell TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }
      }
  
      if (ticket > -1) NoOfTrades++;//Ensure trades are sent only up to MaxTradesAllowed
  }//if(dir == OP_SELLSTOP)

//+------------------------------------------------------------------+
//| expert News function                                             |
//+------------------------------------------------------------------+  

bool NewsExist()
  {
  
    bool News;

    for(int d = 0; d < NoOfPairs; d++)
      {
        int MinutesSincePrevEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,0);

        int MinutesUntilNextEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,1);

        if(MinutesUntilNextEvent < 60 ||
           MinutesSincePrevEvent < 15)
          {
            News = true;
          }
      }
      
    return(News);

  }

//+------------------------------------------------------------------+
//| expert Trend function                                            |
//+------------------------------------------------------------------+  

void Get_Trend(string symbol)
  {
  
    Trend = flat;
    
    EMA_020_M15 = iMA(symbol,M15,020,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_020_H01 = iMA(symbol,H01,020,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_020_H04 = iMA(symbol,H04,020,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_020_D01 = iMA(symbol,D01,020,0,MODE_EMA,PRICE_CLOSE,0);
    
    double EMA_200_M15 = iMA(symbol,M15,200,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_200_H01 = iMA(symbol,H01,200,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_200_H04 = iMA(symbol,H04,200,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_200_D01 = iMA(symbol,D01,200,0,MODE_EMA,PRICE_CLOSE,0);
    
    if(EMA_020_M15 < EMA_200_M15 && EMA_020_H01 < EMA_200_H01 &&
       EMA_020_H04 < EMA_200_H04 && EMA_020_D01 < EMA_200_D01)
      {
        Trend = down;
      }

    if(EMA_020_M15 > EMA_200_M15 && EMA_020_H01 > EMA_200_H01 &&
       EMA_020_H04 > EMA_200_H04 && EMA_020_D01 > EMA_200_D01)
      {
        Trend = up;
      }
       
    return(Trend);
  
  }

void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()

double Get_ATR(string symbol, int tf, int multiplier)
{
   
   return(iATR(symbol, tf, AtrPeriod, 0) * multiplier);
   
}//End double Get_ATR(string symbol, int tf, int multiplier)



bool DoesTradeExist(string symbol)
{
   TicketNo=0;
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >=0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)
      {
         TicketNo = OrderTicket();
         return(true);
      }//if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)      
   }//for (int cc = OrdersTotal() - 1; cc >=0)
   
   //Got this far, so no trade open
   return(false);

}//End bool DoesTradeExist(string symbol)

void ManageTrades()
{
   //Manage moving stops to be and closing half the trade.
   //Close the trade if the trend that allowed it has changed.

   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      while (!IsTradeAllowed() )
      {
         Comment("Trying to manage trades, but trading not allowed by the criminal");
      }//while (!IsTradeAllowed() )
                  
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      string symbol = OrderSymbol();
      if (OrderMagicNumber() ==  MagicNumber && IsTradeAllowed() && OrderLots() > Lots / 2)
      {
         //Look at trade closure
         Get_Trend(symbol);
         if (Trend == flat)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 100, CLR_NONE);
            return;//Cycle around again at the next tick - easier to code
         }//if (Trend = flat)         
         double AtrVal = (Get_ATR(OrderSymbol(), TpAtrTf, TpAtrMultiplier) / 2);
         if (OrderProfit() > 0)
         {
            bool result = false;
            double CloseLots = OrderLots() / 2;
            
            if (OrderType() == OP_BUY)
            {
               double ask = MarketInfo(symbol, MODE_ASK);
               double digits =  MarketInfo(symbol, MODE_DIGITS);
               if (ask >= NormalizeDouble(OrderOpenPrice() + AtrVal, digits) )
               {
                  result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
                  if (!result)
                  {
                       int err=GetLastError();
                       if (ShowAlerts) Alert(Symbol(), " Trend retracement robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                       return;
                  }//if (!result)
                  //Get new ticket number
                  Sleep(100);
                  DoesTradeExist(symbol);
                  OrderSelect(TicketNo, SELECT_BY_TICKET);
                  if (OrderStopLoss() < OrderOpenPrice() )
                  {
                     double SL = OrderOpenPrice();
                     result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
                     if (!result)
                      {
                          err=GetLastError();
                          if (ShowAlerts) Alert(OrderSymbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                          return;
                      }//if (!result)     
                  }//if (OrderStopLoss() < OrderOpenPrice() )
               }//if (ask >= NormalizeDouble(OrderOpenPrice() + AtrVal, digits) )
               
            }//if (OrderType() == OP_BUY)
            
            if (OrderType() == OP_SELL)
            {
               double bid = MarketInfo(symbol, MODE_ASK);
               digits =  MarketInfo(symbol, MODE_DIGITS);
               if (bid <= NormalizeDouble(OrderOpenPrice() - AtrVal, digits) )
               {   
                  result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
                  if (!result)
                  {
                       err=GetLastError();
                       if (ShowAlerts) Alert(OrderSymbol(), " Trend retracement robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                       return;
                  }//if (!result)
                  //Get new ticket number
                  Sleep(100);
                  DoesTradeExist(symbol);
                  OrderSelect(TicketNo, SELECT_BY_TICKET);
                  if (OrderStopLoss() > OrderOpenPrice() )
                  {
                     SL = OrderOpenPrice();
                     result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
                     if (!result)
                      {
                          err=GetLastError();
                          if (ShowAlerts) Alert(Symbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                          return;
                      }//if (!result)     
                  }//if (OrderStopLoss() < OrderOpenPrice() )
               }//if (bid <= NormalizeDouble(OrderOpenPrice() - AtrVal, digits) )
            }//if (OrderType() == OP_SELL)
               
         }//if (OrderProfit() > 0)
         
      }//if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)      
   }//for (int cc = OrdersTotal() - 1; cc >=0)
   
}//void ManageTrades()


//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )

    GetPosition();
    if(NoOfTrades > 0) ManageTrades();
    
    //Check Friday close
   if (FridayClose)
   {
      ClosedForFriday = false;
      if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 5)
      {
         ClosedForFriday = true;
         return;
      }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
   }//if (FridayClose)
   
   //Check Saturday close for Aitipodeans
   if (SaturdayClose)
   {
      ClosedForSaturday = false;
      if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 6)
      {
         ClosedForSaturday = true;
         return;
      }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
   }//if (Saturday)
   
    
    //Trade disable conditions
    if (NewsExist() )
    {
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading disabled because of news event");
         DisplayUserFeedback();
    }//if (NewsExists)
    

    for(int b = 0; b < ArraySize(TradePair); b++)
    {

       if(NoOfTrades >= MaxTradesAllowed) break;
          
       if(iClose(TradePair[b],0,0) > 0)
       {      
         
            bool TradeExists = DoesTradeExist(TradePair[b]);
            Get_Trend(TradePair[b]);
         
            if (!TradeExists)
            {
              double AtrVal = Get_ATR(TradePair[b], RetraceAtrTf, RetraceAtrMultiplier);
              if(Trend == up)
              {
                  double ask = MarketInfo(TradePair[b], MODE_ASK);
                  if (IsTradeAllowed())
                  {   
                     if(ask <= EMA_020_M15 - AtrVal)//Immediate buy trade
                     {                    
                        SendOrder(TradePair[b],OP_BUY,Lots);                   
                     }//if(ask <= EMA_020_M15 - AtrVal)
                     
                     if(ask > EMA_020_M15 - AtrVal)//Pending buy stopade
                     {                    
                        SendOrder(TradePair[b],OP_BUYSTOP, Lots);                   
                     }//if(ask <= EMA_020_M15 - AtrVal)
                     
                     
                  }//if (IsTradeAllowed)
                     
              }//if(Trend == up)

              if(Trend == down)                        
              {
                  double bid = MarketInfo(TradePair[b], MODE_BID);
                  if (IsTradeAllowed())
                  {   
                     if(bid >= EMA_020_M15 + AtrVal)//Immediate sell trade
                     {
                       SendOrder(TradePair[b],OP_SELL,Lots);                       
                     }//if(bid >= EMA_020_M15 + AtrVal)
                     
                     if(bid < EMA_020_M15 + AtrVal)//Pending sell stop
                     {
                       SendOrder(TradePair[b],OP_SELLSTOP,Lots);                       
                     }//if(bid >= EMA_020_M15 + AtrVal)
                  }//if (IsTradeAllowed)   
               }//if(Trend == down)                        
            }//if (!TradeExists)
      
         }//if(iClose(TradePair[b],0,0) > 0)
      
      }//for(int b = 0; b < ArraySize(TradePair); b++)
      
    return(0);

}//End start()


